Index: trunk/source/Lib/TLibCommon/TComRdCost.cpp
===================================================================
--- trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1357)
+++ trunk/source/Lib/TLibCommon/TComRdCost.cpp	(revision 1386)
@@ -41,5 +41,5 @@
 #include "TComRom.h"
 #include "TComRdCost.h"
-#if NH_3D
+#if NH_3D_VSO
 #include "TComDataCU.h"
 #include "TComRectangle.h"
@@ -64,11 +64,13 @@
 // Calculate RD functions
 #if NH_3D_VSO
-Double TComRdCost::calcRdCost( UInt uiBits, Dist uiDistortion, Bool bFlag, DFunc eDFunc )
+Double TComRdCost::calcRdCost( Double numBits, Dist intDistortion, DFunc eDFunc )
+{
+  Double distortion = (Double) intDistortion;
 #else
-Double TComRdCost::calcRdCost( UInt uiBits, Distortion uiDistortion, Bool bFlag, DFunc eDFunc )
-#endif
-{
-  Double dRdCost = 0.0;
-  Double dLambda = 0.0;
+Double TComRdCost::calcRdCost( Double numBits, Double distortion, DFunc eDFunc )
+{
+#endif
+  
+  Double lambda = 1.0;
 
   switch ( eDFunc )
@@ -78,15 +80,11 @@
       break;
     case DF_SAD:
-#if RExt__HIGH_BIT_DEPTH_SUPPORT
-      dLambda = m_dLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
-#else
-      dLambda = (Double)m_uiLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
-#endif
+      lambda = m_dLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
       break;
     case DF_DEFAULT:
-      dLambda =         m_dLambda;
+      lambda = m_dLambda;
       break;
     case DF_SSE_FRAME:
-      dLambda =         m_dFrameLambda;
+      lambda = m_dFrameLambda;
       break;
     default:
@@ -95,119 +93,31 @@
   }
 
-  if (bFlag) //NOTE: this "bFlag" is never true
-  {
-    // Intra8x8, Intra4x4 Block only...
+#if NH_MV
+  // D_PRINT_INDENT( g_traceRDCost,  "Dist: " + n2s(distortion) + " Bits: " + n2s(numBits) + " RD Cost: " + n2s(dRdCost)); 
+   D_PRINT_INDENT( g_traceRDCost,  "Dist: " + n2s(distortion) + " Bits: " + n2s(numBits) ); 
+#endif
+
+  if (eDFunc == DF_SAD)
+  {
     if (m_costMode != COST_STANDARD_LOSSY)
     {
-      dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
+      return ((distortion * 65536.0) / lambda) + numBits; // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
     }
     else
     {
-      dRdCost = (((Double)uiDistortion) + ((Double)uiBits * dLambda));
+      return distortion + (((numBits * lambda) ) / 65536.0);
     }
   }
   else
   {
-    if (eDFunc == DF_SAD)
-    {
-      if (m_costMode != COST_STANDARD_LOSSY)
-      {
-        dRdCost = ((Double(uiDistortion) * 65536) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
-      }
-      else
-      {
-        dRdCost = floor(Double(uiDistortion) + (floor((Double(uiBits) * dLambda) + 0.5) / 65536.0));
-      }
+    if (m_costMode != COST_STANDARD_LOSSY)
+    {
+      return (distortion / lambda) + numBits; // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
     }
     else
     {
-      if (m_costMode != COST_STANDARD_LOSSY)
-      {
-        dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
-      }
-      else
-      {
-        dRdCost = floor(Double(uiDistortion) + (Double(uiBits) * dLambda) + 0.5);
-      }
-    }
-  }
-
-#if NH_MV
-  D_PRINT_INDENT( g_traceRDCost,  "Dist: " + n2s(uiDistortion) + " Bits: " + n2s(uiBits) + " RD Cost: " + n2s(dRdCost)); 
-#endif
-  return dRdCost;
-}
-
-#if NH_3D_VSO
-Double TComRdCost::calcRdCost64( UInt64 uiBits, Dist64 uiDistortion, Bool bFlag, DFunc eDFunc )
-#else
-Double TComRdCost::calcRdCost64( UInt64 uiBits, UInt64 uiDistortion, Bool bFlag, DFunc eDFunc )
-#endif
-{
-  Double dRdCost = 0.0;
-  Double dLambda = 0.0;
-
-  switch ( eDFunc )
-  {
-    case DF_SSE:
-      assert(0);
-      break;
-    case DF_SAD:
-#if RExt__HIGH_BIT_DEPTH_SUPPORT
-      dLambda = m_dLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
-#else
-      dLambda = (Double)m_uiLambdaMotionSAD[0]; // 0 is valid, because for lossless blocks, the cost equation is modified to compensate.
-#endif
-      break;
-    case DF_DEFAULT:
-      dLambda =         m_dLambda;
-      break;
-    case DF_SSE_FRAME:
-      dLambda =         m_dFrameLambda;
-      break;
-    default:
-      assert (0);
-      break;
-  }
-
-  if (bFlag) //NOTE: this "bFlag" is never true
-  {
-    // Intra8x8, Intra4x4 Block only...
-    if (m_costMode != COST_STANDARD_LOSSY)
-    {
-      dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
-    }
-    else
-    {
-      dRdCost = (((Double)(Int64)uiDistortion) + ((Double)(Int64)uiBits * dLambda));
-    }
-  }
-  else
-  {
-    if (eDFunc == DF_SAD)
-    {
-      if (m_costMode != COST_STANDARD_LOSSY)
-      {
-        dRdCost = ((Double(uiDistortion) * 65536) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
-      }
-      else
-      {
-        dRdCost = floor(Double(uiDistortion) + (floor((Double(uiBits) * dLambda) + 0.5) / 65536.0));
-      }
-    }
-    else
-    {
-      if (m_costMode != COST_STANDARD_LOSSY)
-      {
-        dRdCost = (Double(uiDistortion) / dLambda) + Double(uiBits); // all lossless costs would have uiDistortion=0, and therefore this cost function can be used.
-      }
-      else
-      {
-        dRdCost = floor(Double(uiDistortion) + (Double(uiBits) * dLambda) + 0.5);
-      }
-    }
-  }
-
-  return dRdCost;
+      return distortion + (numBits * lambda);
+    }
+  }
 }
 
@@ -216,5 +126,4 @@
   m_dLambda           = dLambda;
   m_sqrtLambda        = sqrt(m_dLambda);
-#if RExt__HIGH_BIT_DEPTH_SUPPORT
   m_dLambdaMotionSAD[0] = 65536.0 * m_sqrtLambda;
   m_dLambdaMotionSSE[0] = 65536.0 * m_dLambda;
@@ -226,15 +135,4 @@
   m_dLambdaMotionSAD[1] = 65536.0 * sqrt(dLambda);
   m_dLambdaMotionSSE[1] = 65536.0 * dLambda;
-#else
-  m_uiLambdaMotionSAD[0] = (UInt)floor(65536.0 * m_sqrtLambda);
-  m_uiLambdaMotionSSE[0] = (UInt)floor(65536.0 * m_dLambda   );
-#if FULL_NBIT
-  dLambda = 0.57 * pow(2.0, ((LOSSLESS_AND_MIXED_LOSSLESS_RD_COST_TEST_QP_PRIME - 12) / 3.0));
-#else
-  dLambda = 0.57 * pow(2.0, ((LOSSLESS_AND_MIXED_LOSSLESS_RD_COST_TEST_QP_PRIME - 12 - 6 * (bitDepths.recon[CHANNEL_TYPE_LUMA] - 8)) / 3.0));
-#endif
-  m_uiLambdaMotionSAD[1] = (UInt)floor(65536.0 * sqrt(dLambda));
-  m_uiLambdaMotionSSE[1] = (UInt)floor(65536.0 * dLambda   );
-#endif
 }
 
@@ -298,9 +196,5 @@
   m_costMode                   = COST_STANDARD_LOSSY;
 
-#if RExt__HIGH_BIT_DEPTH_SUPPORT
-  m_dCost                      = 0;
-#else
-  m_uiCost                     = 0;
-#endif
+  m_motionLambda               = 0;
   m_iCostScale                 = 0;
 
@@ -370,8 +264,9 @@
   // initialize
   rcDistParam.iSubShift  = 0;
+  rcDistParam.m_maximumDistortionForEarlyExit = std::numeric_limits<Distortion>::max();
 }
 
 // Setting the Distortion Parameter for Inter (ME)
-Void TComRdCost::setDistParam( TComPattern* pcPatternKey, Pel* piRefY, Int iRefStride, DistParam& rcDistParam )
+Void TComRdCost::setDistParam( const TComPattern* const pcPatternKey, const Pel* piRefY, Int iRefStride, DistParam& rcDistParam )
 {
   // set Original & Curr Pointer / Stride
@@ -386,4 +281,5 @@
   rcDistParam.iRows    = pcPatternKey->getROIYHeight();
   rcDistParam.DistFunc = m_afpDistortFunc[DF_SAD + g_aucConvertToBit[ rcDistParam.iCols ] + 1 ];
+  rcDistParam.m_maximumDistortionForEarlyExit = std::numeric_limits<Distortion>::max();
 
   if (rcDistParam.iCols == 12)
@@ -411,5 +307,5 @@
 
 // Setting the Distortion Parameter for Inter (subpel ME with step)
-Void TComRdCost::setDistParam( TComPattern* pcPatternKey, Pel* piRefY, Int iRefStride, Int iStep, DistParam& rcDistParam, Bool bHADME )
+Void TComRdCost::setDistParam( const TComPattern* const pcPatternKey, const Pel* piRefY, Int iRefStride, Int iStep, DistParam& rcDistParam, Bool bHADME )
 {
   // set Original & Curr Pointer / Stride
@@ -427,4 +323,6 @@
   rcDistParam.iRows    = pcPatternKey->getROIYHeight();
 
+  rcDistParam.m_maximumDistortionForEarlyExit = std::numeric_limits<Distortion>::max();
+
   // set distortion function
   if ( !bHADME )
@@ -459,5 +357,5 @@
 }
 
-Void TComRdCost::setDistParam( DistParam& rcDP, Int bitDepth, Pel* p1, Int iStride1, Pel* p2, Int iStride2, Int iWidth, Int iHeight, Bool bHadamard )
+Void TComRdCost::setDistParam( DistParam& rcDP, Int bitDepth, const Pel* p1, Int iStride1, const Pel* p2, Int iStride2, Int iWidth, Int iHeight, Bool bHadamard )
 {
   rcDP.pOrg       = p1;
@@ -471,4 +369,5 @@
   rcDP.bitDepth   = bitDepth;
   rcDP.DistFunc   = m_afpDistortFunc[ ( bHadamard ? DF_HADS : DF_SADS ) + g_aucConvertToBit[ iWidth ] + 1 ];
+  rcDP.m_maximumDistortionForEarlyExit = std::numeric_limits<Distortion>::max();
 #if NH_3D_DBBP
   if( m_bUseMask )
@@ -479,5 +378,5 @@
 }
 
-Distortion TComRdCost::calcHAD( Int bitDepth, Pel* pi0, Int iStride0, Pel* pi1, Int iStride1, Int iWidth, Int iHeight )
+Distortion TComRdCost::calcHAD( Int bitDepth, const Pel* pi0, Int iStride0, const Pel* pi1, Int iStride1, Int iWidth, Int iHeight )
 {
   Distortion uiSum = 0;
@@ -550,5 +449,5 @@
 
 
-Distortion TComRdCost::getDistPart( Int bitDepth, Pel* piCur, Int iCurStride,  Pel* piOrg, Int iOrgStride, UInt uiBlkWidth, UInt uiBlkHeight, const ComponentID compID, DFunc eDFunc )
+Distortion TComRdCost::getDistPart( Int bitDepth, const Pel* piCur, Int iCurStride,  const Pel* piOrg, Int iOrgStride, UInt uiBlkWidth, UInt uiBlkHeight, const ComponentID compID, DFunc eDFunc )
 {
   DistParam cDtParam;
@@ -604,6 +503,7 @@
 
   cDtParam.bitDepth   = bitDepth;
-
+#if NH_3D
   cDtParam.bUseIC       = false;
+#endif
 #if NH_3D_SDC_INTER
   cDtParam.bUseSDCMRSAD = false;
@@ -663,6 +563,6 @@
 UInt TComRdCost::xGetMaskedSSE( DistParam* pcDtParam )
 {
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iCols   = pcDtParam->iCols;
@@ -701,6 +601,6 @@
 #endif
   
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iCols   = pcDtParam->iCols;
@@ -729,8 +629,8 @@
 UInt TComRdCost::xGetMaskedVSD( DistParam* pcDtParam )
 {
-  Pel* piOrg    = pcDtParam->pOrg;
-  Pel* piCur    = pcDtParam->pCur;
-  Pel* piVirRec = pcDtParam->pVirRec;
-  Pel* piVirOrg = pcDtParam->pVirOrg;
+  const Pel* piOrg    = pcDtParam->pOrg;
+  const Pel* piCur    = pcDtParam->pCur;
+  const Pel* piVirRec = pcDtParam->pVirRec;
+  const Pel* piVirOrg = pcDtParam->pVirOrg;
   Int  iRows    = pcDtParam->iRows;
   Int  iCols    = pcDtParam->iCols;
@@ -786,12 +686,12 @@
   const Pel* piOrg   = pcDtParam->pOrg;
   const Pel* piCur   = pcDtParam->pCur;
-  Int  iRows   = pcDtParam->iRows;
-  Int  iCols   = pcDtParam->iCols;
-  Int  iStrideCur = pcDtParam->iStrideCur;
-  Int  iStrideOrg = pcDtParam->iStrideOrg;
+  const Int  iCols           = pcDtParam->iCols;
+  const Int  iStrideCur      = pcDtParam->iStrideCur;
+  const Int  iStrideOrg      = pcDtParam->iStrideOrg;
+  const UInt distortionShift = DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth - 8);
 
   Distortion uiSum = 0;
 
-  for( ; iRows != 0; iRows-- )
+  for(Int iRows = pcDtParam->iRows ; iRows != 0; iRows-- )
   {
     for (Int n = 0; n < iCols; n++ )
@@ -799,9 +699,13 @@
       uiSum += abs( piOrg[n] - piCur[n] );
     }
-    piOrg += iStrideOrg;
-    piCur += iStrideCur;
-  }
-
-  return ( uiSum >> DISTORTION_PRECISION_ADJUSTMENT(pcDtParam->bitDepth-8) );
+    if (pcDtParam->m_maximumDistortionForEarlyExit < ( uiSum >> distortionShift ))
+    {
+      return ( uiSum >> distortionShift );
+    }
+    piOrg += iStrideOrg;
+    piCur += iStrideCur;
+  }
+
+  return ( uiSum >> distortionShift );
 }
 
@@ -1403,6 +1307,6 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iCols   = pcDtParam->iCols;
@@ -1451,6 +1355,6 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1508,6 +1412,6 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-  Pel* piOrg      = pcDtParam->pOrg;
-  Pel* piCur      = pcDtParam->pCur;
+  const Pel* piOrg      = pcDtParam->pOrg;
+  const Pel* piCur      = pcDtParam->pCur;
   Int  iRows      = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1577,6 +1481,6 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1670,6 +1574,6 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1748,6 +1652,6 @@
 UInt TComRdCost::xGetSAD16Nic( DistParam* pcDtParam )
 {
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iCols   = pcDtParam->iCols;
@@ -1845,6 +1749,6 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -1987,6 +1891,6 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -2104,6 +2008,6 @@
     return TComRdCostWeightPrediction::xGetSADw( pcDtParam );
   }
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -2343,6 +2247,6 @@
   }
 
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
   Int  iRows   = pcDtParam->iRows;
   Int  iSubShift  = pcDtParam->iSubShift;
@@ -2879,5 +2783,5 @@
 #if NH_3D_VSO
 //SAIT_VSO_EST_A0033
-UInt TComRdCost::getVSDEstimate( Int dDM, Pel* pOrg, Int iOrgStride,  Pel* pVirRec, Pel* pVirOrg, Int iVirStride, Int x, Int y )
+UInt TComRdCost::getVSDEstimate( Int dDM, const Pel* pOrg, Int iOrgStride, const Pel* pVirRec, const Pel* pVirOrg, Int iVirStride, Int x, Int y )
 { 
   // change to use bit depth from DistParam struct
@@ -2894,8 +2798,8 @@
 UInt TComRdCost::xGetVSD( DistParam* pcDtParam )
 {
-  Pel* piOrg    = pcDtParam->pOrg;
-  Pel* piCur    = pcDtParam->pCur;
-  Pel* piVirRec = pcDtParam->pVirRec;
-  Pel* piVirOrg = pcDtParam->pVirOrg;
+  const Pel* piOrg    = pcDtParam->pOrg;
+  const Pel* piCur    = pcDtParam->pCur;
+  const Pel* piVirRec = pcDtParam->pVirRec;
+  const Pel* piVirOrg = pcDtParam->pVirOrg;
   Int  iRows    = pcDtParam->iRows;
   Int  iCols    = pcDtParam->iCols;
@@ -2925,8 +2829,8 @@
 UInt TComRdCost::xGetVSD4( DistParam* pcDtParam )
 {
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
-  Pel* piVirRec = pcDtParam->pVirRec;
-  Pel* piVirOrg = pcDtParam->pVirOrg;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
+  const Pel* piVirRec = pcDtParam->pVirRec;
+  const Pel* piVirOrg = pcDtParam->pVirOrg;
   Int  iRows   = pcDtParam->iRows;
   Int  iStrideOrg = pcDtParam->iStrideOrg;
@@ -2955,8 +2859,8 @@
 UInt TComRdCost::xGetVSD8( DistParam* pcDtParam )
 {
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
-  Pel* piVirRec = pcDtParam->pVirRec;
-  Pel* piVirOrg = pcDtParam->pVirOrg;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
+  const Pel* piVirRec = pcDtParam->pVirRec;
+  const Pel* piVirOrg = pcDtParam->pVirOrg;
   Int  iRows   = pcDtParam->iRows;
   Int  iStrideOrg = pcDtParam->iStrideOrg;
@@ -2985,8 +2889,8 @@
 UInt TComRdCost::xGetVSD16( DistParam* pcDtParam )
 {
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
-  Pel* piVirRec = pcDtParam->pVirRec;
-  Pel* piVirOrg = pcDtParam->pVirOrg;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
+  const Pel* piVirRec = pcDtParam->pVirRec;
+  const Pel* piVirOrg = pcDtParam->pVirOrg;
   Int  iRows   = pcDtParam->iRows;
   Int  iStrideOrg = pcDtParam->iStrideOrg;
@@ -3015,8 +2919,8 @@
 UInt TComRdCost::xGetVSD16N( DistParam* pcDtParam )
 {
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
-  Pel* piVirRec = pcDtParam->pVirRec;
-  Pel* piVirOrg = pcDtParam->pVirOrg;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
+  const Pel* piVirRec = pcDtParam->pVirRec;
+  const Pel* piVirOrg = pcDtParam->pVirOrg;
   Int  iRows   = pcDtParam->iRows;
   Int  iCols   = pcDtParam->iCols;
@@ -3049,8 +2953,8 @@
 UInt TComRdCost::xGetVSD32( DistParam* pcDtParam )
 {
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
-  Pel* piVirRec = pcDtParam->pVirRec;
-  Pel* piVirOrg = pcDtParam->pVirOrg;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
+  const Pel* piVirRec = pcDtParam->pVirRec;
+  const Pel* piVirOrg = pcDtParam->pVirOrg;
   Int  iRows   = pcDtParam->iRows;
   Int  iStrideOrg = pcDtParam->iStrideOrg;
@@ -3079,8 +2983,8 @@
 UInt TComRdCost::xGetVSD64( DistParam* pcDtParam )
 {
-  Pel* piOrg      = pcDtParam->pOrg;
-  Pel* piCur      = pcDtParam->pCur;
-  Pel* piVirRec   = pcDtParam->pVirRec;
-  Pel* piVirOrg   = pcDtParam->pVirOrg;
+  const Pel* piOrg      = pcDtParam->pOrg;
+  const Pel* piCur      = pcDtParam->pCur;
+  const Pel* piVirRec   = pcDtParam->pVirRec;
+  const Pel* piVirOrg   = pcDtParam->pVirOrg;
   Int  iRows      = pcDtParam->iRows;
   Int  iStrideOrg = pcDtParam->iStrideOrg;
@@ -3113,5 +3017,5 @@
 // --------------------------------------------------------------------------------------------------------------------
 
-Distortion TComRdCost::xCalcHADs2x2( Pel *piOrg, Pel *piCur, Int iStrideOrg, Int iStrideCur, Int iStep )
+Distortion TComRdCost::xCalcHADs2x2( const Pel *piOrg, const Pel *piCur, Int iStrideOrg, Int iStrideCur, Int iStep )
 {
   Distortion satd = 0;
@@ -3135,5 +3039,5 @@
 }
 
-Distortion TComRdCost::xCalcHADs4x4( Pel *piOrg, Pel *piCur, Int iStrideOrg, Int iStrideCur, Int iStep )
+Distortion TComRdCost::xCalcHADs4x4( const Pel *piOrg, const Pel *piCur, Int iStrideOrg, Int iStrideCur, Int iStep )
 {
   Int k;
@@ -3231,5 +3135,5 @@
 }
 
-Distortion TComRdCost::xCalcHADs8x8( Pel *piOrg, Pel *piCur, Int iStrideOrg, Int iStrideCur, Int iStep )
+Distortion TComRdCost::xCalcHADs8x8( const Pel *piOrg, const Pel *piCur, Int iStrideOrg, Int iStrideCur, Int iStep )
 {
   Int k, i, j, jj;
@@ -3348,11 +3252,11 @@
 #endif
 
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
-  Int  iRows   = pcDtParam->iRows;
-  Int  iCols   = pcDtParam->iCols;
-  Int  iStrideCur = pcDtParam->iStrideCur;
-  Int  iStrideOrg = pcDtParam->iStrideOrg;
-  Int  iStep  = pcDtParam->iStep;
+  const Pel* piOrg      = pcDtParam->pOrg;
+  const Pel* piCur      = pcDtParam->pCur;
+  const Int  iRows      = pcDtParam->iRows;
+  const Int  iCols      = pcDtParam->iCols;
+  const Int  iStrideCur = pcDtParam->iStrideCur;
+  const Int  iStrideOrg = pcDtParam->iStrideOrg;
+  const Int  iStep      = pcDtParam->iStep;
 
   Int  x, y;
@@ -3418,6 +3322,7 @@
     return TComRdCostWeightPrediction::xGetHADsw( pcDtParam );
   }
-  Pel* piOrg   = pcDtParam->pOrg;
-  Pel* piCur   = pcDtParam->pCur;
+  const Pel* piOrg   = pcDtParam->pOrg;
+  const Pel* piCur   = pcDtParam->pCur;
+  
   Int  iRows   = pcDtParam->iRows;
   Int  iCols   = pcDtParam->iCols;
@@ -3449,12 +3354,21 @@
   iDeltaC = (iOrigAvg - iCurAvg)/iRows/iCols;
 
+  const Int orgMaxSize = MAX_CU_SIZE*MAX_CU_SIZE;
+  assert( iRows * iCols <= orgMaxSize ); 
+  
+  Pel orgMinusDeltaDc[ orgMaxSize ];
+  Pel* tempOrgMinusDeltaDc = orgMinusDeltaDc; 
+  
   for ( y=0; y<iRows; y++ )
   {
     for ( x=0; x<iCols; x++ )
     {        
-      piOrg[x] -= iDeltaC;
-    }
-    piOrg += iStrideOrg;
-  }
+      tempOrgMinusDeltaDc[x] = (piOrg[x] - iDeltaC);
+    }
+    piOrg               += iStrideOrg;
+    tempOrgMinusDeltaDc += iStrideOrg;
+  }
+
+  tempOrgMinusDeltaDc = orgMinusDeltaDc; 
 
   piOrg   = pcDtParam->pOrg;
@@ -3472,8 +3386,8 @@
       for ( x=0; x<iCols; x+= 8 )
       {
-        uiSum += xCalcHADs8x8( &piOrg[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
+        uiSum += xCalcHADs8x8( &tempOrgMinusDeltaDc[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
       }
-      piOrg += iOffsetOrg;
-      piCur += iOffsetCur;
+      tempOrgMinusDeltaDc += iOffsetOrg;
+      piCur               += iOffsetCur;
     }
   }
@@ -3487,8 +3401,8 @@
       for ( x=0; x<iCols; x+= 16 )
       {
-        uiSum += xCalcHADs16x4( &piOrg[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
+        uiSum += xCalcHADs16x4( &tempOrgMinusDeltaDc[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
       }
-      piOrg += iOffsetOrg;
-      piCur += iOffsetCur;
+      tempOrgMinusDeltaDc += iOffsetOrg;
+      piCur               += iOffsetCur;
     }
   }
@@ -3501,8 +3415,8 @@
       for ( x=0; x<iCols; x+= 4 )
       {
-        uiSum += xCalcHADs4x16( &piOrg[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
+        uiSum += xCalcHADs4x16( &tempOrgMinusDeltaDc[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
       }
-      piOrg += iOffsetOrg;
-      piCur += iOffsetCur;
+      tempOrgMinusDeltaDc += iOffsetOrg;
+      piCur               += iOffsetCur;
     }
   }
@@ -3517,8 +3431,8 @@
       for ( x=0; x<iCols; x+= 4 )
       {
-        uiSum += xCalcHADs4x4( &piOrg[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
+        uiSum += xCalcHADs4x4( &tempOrgMinusDeltaDc[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
       }
-      piOrg += iOffsetOrg;
-      piCur += iOffsetCur;
+      tempOrgMinusDeltaDc += iOffsetOrg;
+      piCur               += iOffsetCur;
     }
   }
@@ -3531,8 +3445,8 @@
       for ( x=0; x<iCols; x+=2 )
       {
-        uiSum += xCalcHADs2x2( &piOrg[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
+        uiSum += xCalcHADs2x2( &tempOrgMinusDeltaDc[x], &piCur[x*iStep], iStrideOrg, iStrideCur, iStep );
       }
-      piOrg += iOffsetOrg;
-      piCur += iOffsetCur;
+      tempOrgMinusDeltaDc += iOffsetOrg;
+      piCur               += iOffsetCur;
     }
   }
@@ -3540,15 +3454,4 @@
   {
     assert(false);
-  }
-
-  piOrg   = pcDtParam->pOrg;
-
-  for ( y=0; y<iRows; y++ )
-  {
-    for ( x=0; x<iCols; x++ )
-    {        
-      piOrg[x] += iDeltaC;
-    }
-    piOrg += iStrideOrg;
   }
 
